import processing.pdf.*;
boolean pdfStart;


void draw() {

  background(255);

  img.loadPixels();
  for (int y = 0; y < img.height ; y+=dotSize) {
    for (int x = 0 ; x < img.width ; x+=dotSize) {
      int pos = y*img.width + x;

      float red_pos = red(img.pixels[pos]);
      float green_pos = green(img.pixels[pos]);
      float blue_pos = blue(img.pixels[pos]);

      float colDis = 255*3;
      int useCol = 0;
      for (int i=0 ; i < colNum ; i++) {
        float colDis_ = dist(red_pos, green_pos, blue_pos, red(col[i]), green(col[i]), blue(col[i]));
        if (colDis_ < colDis) {
          useCol = i;
          colDis = colDis_;
        }
      }

      fill(col[useCol]);

      if (square_ == true) { 
        rect(x+img.width, y, dotSize, dotSize);
      }
      else {
        ellipse(x+img.width, y, dotSize, dotSize);
      }
    }
  }
  img.updatePixels();

  image(img, 0, 0);
  noStroke();
  fill(col[0]);
  rect(210+60, img.height, 19, 19);
  fill(col[1]);
  rect(210+60, img.height+buttonHeight, 19, 19);
  fill(col[2]);
  rect(210+60, img.height+buttonHeight*2, 19, 19);
}


void dotSize(int thedotSize) {
  dotSize = int(thedotSize);
}

void toggle(boolean theSquare) {
  if (theSquare==true) {
    square_ = false;
  } 
  else {
    square_  = true;
  }
  println("a toggle event.");
}

void mousePressed() {
  if (mouseX < width && mouseY < img.height) {
    colSelect = color(img.pixels[mouseX + mouseY * img.width]);
  }
}

public void colorA(int theValue) {
  col[0] = colSelect;
}

public void colorB(int theValue) {
  col[1] = colSelect;
}

public void colorC(int theValue) {
  col[2] = colSelect;
}



//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


public void Exit_(int theValue) {

  beginRecord(PDF, "grid0.pdf"); //PDFの作成開始

  for (int y = 0; y < img.height ; y+=dotSize) {
    for (int x = 0 ; x < img.width ; x+=dotSize) {
      int pos = y*img.width + x;

      float red_pos = red(img.pixels[pos]);
      float green_pos = green(img.pixels[pos]);
      float blue_pos = blue(img.pixels[pos]);

      float colDis = 255*3;
      int useCol = 0;
      for (int i=0 ; i < colNum ; i++) {
        float colDis_ = dist(red_pos, green_pos, blue_pos, red(col[i]), green(col[i]), blue(col[i]));
        if (colDis_ < colDis) {
          useCol = i;
          colDis = colDis_;
        }
      }

      if (useCol == 0) {
        stroke(col[useCol]);
        noFill();
        strokeWeight(0.001);

        if (square_ == true) { 
          rect(x+img.width, y, dotSize - 2, dotSize - 2);
        }
        else {
          ellipse(x+img.width, y, dotSize - 2, dotSize - 2 );
        }
      }
    }
  }
  img.updatePixels();
  rect(img.width,0,img.width,img.height);
  
  endRecord();                  //PDFの作成終了

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  beginRecord(PDF, "grid1.pdf"); //PDFの作成開始
  
    for (int y = 0; y < img.height ; y+=dotSize) {
    for (int x = 0 ; x < img.width ; x+=dotSize) {
      int pos = y*img.width + x;

      float red_pos = red(img.pixels[pos]);
      float green_pos = green(img.pixels[pos]);
      float blue_pos = blue(img.pixels[pos]);

      float colDis = 255*3;
      int useCol = 0;
      for (int i=0 ; i < colNum ; i++) {
        float colDis_ = dist(red_pos, green_pos, blue_pos, red(col[i]), green(col[i]), blue(col[i]));
        if (colDis_ < colDis) {
          useCol = i;
          colDis = colDis_;
        }
      }

      if (useCol == 1) {
        stroke(col[useCol]);
        noFill();
        strokeWeight(0.001);

        if (square_ == true) { 
          rect(x+img.width, y, dotSize - 2, dotSize - 2);
        }
        else {
          ellipse(x+img.width, y, dotSize - 2, dotSize - 2 );
        }
      }
    }
  }
  img.updatePixels();
  rect(img.width,0,img.width,img.height);

  endRecord();                  //PDFの作成終了
  
  ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

  beginRecord(PDF, "grid2.pdf"); //PDFの作成開始
  
    for (int y = 0; y < img.height ; y+=dotSize) {
    for (int x = 0 ; x < img.width ; x+=dotSize) {
      int pos = y*img.width + x;

      float red_pos = red(img.pixels[pos]);
      float green_pos = green(img.pixels[pos]);
      float blue_pos = blue(img.pixels[pos]);

      float colDis = 255*3;
      int useCol = 0;
      for (int i=0 ; i < colNum ; i++) {
        float colDis_ = dist(red_pos, green_pos, blue_pos, red(col[i]), green(col[i]), blue(col[i]));
        if (colDis_ < colDis) {
          useCol = i;
          colDis = colDis_;
        }
      }

      if (useCol == 2) {
        stroke(col[useCol]);
        noFill();
        strokeWeight(0.001);

        if (square_ == true) { 
          rect(x+img.width, y, dotSize - 2, dotSize - 2);
        }
        else {
          ellipse(x+img.width, y, dotSize - 2, dotSize - 2 );
        }
      }
    }
  }
  img.updatePixels();
  rect(img.width,0,img.width,img.height);

  endRecord();                  //PDFの作成終了
  
 ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
  
}


